; PW 1.1 by Joe Wingbermuehle 19990220

	.nolist
	#include	"joeti83.inc"
	#include	"sos.inc"
	.org	$9327
	.list

	nop
	jr	start_of_program
	.dw	0
	.dw	description
start_of_program:
	ld	a,1
	out	(3),a
	ei
	halt
	call	homeup
	ld	hl,pw
	call	puts
	call	zeroop1
	ld	hl,op1
	ld	e,8
key_loop:
	ld	d,$FF
key1:	push	de
	push	hl
	ei
	halt
	call	getk
	pop	hl
	pop	de
	dec	d
	jr	z,start_of_program
	or	a
	jr	z,key1
	cp	9	; [ENTER]
	jr	z,exit
	cp	55	; [MODE]
	jr	z,change_pw
	ld	(hl),a
	ld	a,e
	or	a
	jr	z,key_loop
	inc	hl
	dec	e
	jr	key_loop
exit:	call	check_pw
	jr	nz,start_of_program
	ret

;-----> Change password
change_pw:
	call	check_pw
	jr	nz,start_of_program
	call	homeup
	ld	hl,new_pw
	call	puts
	ld	b,8
	ld	hl,password+8
clear_pw_loop:
	dec	hl
	ld	(hl),0
	djnz	clear_pw_loop
	ld	e,8
change_loop:
	push	de
	push	hl
key2:	call	getk
	or	a
	jr	z,key2
	pop	hl
	pop	de
	cp	9
	ret	z
	ld	(hl),a
	inc	hl
	dec	e
	jr	nz,change_loop
	ret

;-----> Check password
check_pw:
	ld	hl,password
	ld	de,op1
	ld	b,8
check_loop:
	ld	a,(de)
	cp	(hl)
	ret	nz
	inc	hl
	inc	de
	djnz	check_loop
	ret

;-----> Variables
password:
	.db	0,0,0,0,0,0,0,0

;-----> Constants
description:
	.db	"PW 1.1 - Joe W"
	.db	0

new_pw:
	.db	"New "
pw:	.db	"Password?",0

.end
END